/* Exercice no. 3 */ 

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include "authorisation.h"

int 
authorisation(char *chemin, int mode)
{
  int i,ret;
  int n = strlen(chemin);
  char *path=malloc(n + 1);
  
  for(i=0;i < n ;i++)
    {
      if( chemin[i] == '/' || i == n - 1 )
	{
	  strncpy(path,chemin,i+1);
	  path[i+1] = '\0';

	  if( i == n-1 )
	    ret = loc_author(path,mode);
	  else
	    ret = loc_author(path,EXEC);

	  switch(ret){
	  case NONACCESSIBLE:
	    free(path);
	    return NONACCESSIBLE;
	  case CODEERREUR:
	    free(path);
	    return CODEERREUR;
	  default:
	  case ACCESSIBLE:
	    break;
	  }
	}
    }

  free(path);
  return ACCESSIBLE;
}

/* mode_demande peut etre un nombre entre 0 et 7 */ 
int 
loc_author(char *chemin, int mode_demande)
{
  char errmess[TAILLEERRBUF];
  struct stat buf;
  int decalage ;
  mode_t mode_du_fichier;
  
  if(stat(chemin,&buf) == -1 )
    {
      snprintf(errmess,TAILLEERRBUF,"stat sur fichier %s", chemin);
      perror(errmess);
      return CODEERREUR; 
    }

  if(buf.st_uid==getuid())
    decalage =  6; /* Je suis USR */
  else if (buf.st_gid==getgid())
    decalage = 3;  /* Je suis GRP */
  else
    decalage = 0;  /* Je suis OTH */

  mode_du_fichier = (buf.st_mode >> decalage) & 07;

  if( (mode_du_fichier & mode_demande) == mode_demande)
    return ACCESSIBLE;
  else
    return NONACCESSIBLE;
}
