/* Exercice no. 1 : identique.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#define PRINTINFOS(chemin,statbuf) \
printf("Chemin \"%s\" :\n" \
       "priphrique no. %lu, i-noeud no. %lu.\n", \
       (chemin),(unsigned long)(statbuf).st_dev,(statbuf).st_ino) \


char * chemin1, *chemin2;
int (*ce_stat)(const char *, struct stat *);

void setoptions(int argc,char *argv[]); 
void usage(char *);

int
main(int argc, char *argv[])
{
  struct stat buf1, buf2;

  setoptions(argc,argv);

  if( ce_stat(chemin1,&buf1) == -1 || ce_stat(chemin2,&buf2) == -1 )
    {
      perror("stat");
      usage(argv[0]);
    }

  PRINTINFOS(chemin1,buf1);
  PRINTINFOS(chemin2,buf2);
 
  printf("Les chemins \"%s\" et \"%s\" ",chemin1,chemin2);
  if(buf1.st_dev == buf2.st_dev && buf1.st_ino == buf2.st_ino)
    printf("rfrencent le mme fichier.\n");
  else
    printf("ne rfrencent pas le mme fichier.\n");
  
  return EXIT_SUCCESS;
}

void setoptions(int argc, char * argv[])
{
  if( argc < 3)
    usage(argv[0]);

  if(strcmp(argv[1],"-L") == 0)
    {
      if( argc != 4)
	usage(argv[0]);

      /* Si on NE veut PAS suivre les liens symboliques */
      /* il faut utiliser lstat. */
      ce_stat=lstat;
      chemin1=argv[2];
      chemin2=argv[3];
    }
  else
    {
      /* Si on veut suivre les liens symboliques */
      /* il faut utiliser stat. */
      ce_stat=stat;
      chemin1=argv[1];
      chemin2=argv[2];
    }
}

void usage(char *s)
{
  fprintf(stderr,"\nUsage : %s [-L] chemin1 chemin2\n",s);
  exit(EXIT_FAILURE);
}
