/* Exercice no. 3 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include "authorisation.h"

static void 
usage(char *s);

int
main(int argc, char *argv[])
{
  int ret;
  char c;
  
  if( argc != 3 )
    usage(argv[0]);

  if( strlen(argv[2]) != 1 )
      usage(argv[0]);
  
  c = argv[2][0];
  switch(c)
  {
  case 'r':
    ret = authorisation(argv[1],READ);
    break;
  case 'w':
    ret = authorisation(argv[1],WRITE);
    break;
  case 'x':
    ret = authorisation(argv[1],EXEC); 
    break;
  default:
    usage(argv[0]);
  }
 
  switch(ret)
    {
    case ACCESSIBLE:
      printf("Fichier est accessible.\n");
      break;
    case NONACCESSIBLE :
      printf("Fichier n'est pas accessible.\n");
      break;
    case CODEERREUR :
    default:
      exit(EXIT_FAILURE);
    }
  
  return EXIT_SUCCESS;
}

static void
usage(char *s)
{
  fprintf(stderr,"Usage : %s fichier [rwx]\n",s);
  exit(EXIT_FAILURE);
}
